
*creat your log file, replace ... with your directory
log using "...\cincinnatiagds.smcl", replace

*point to you data location, replace ... with your directory
use "...\cadshots.dta"


*1. run descriptives on response time variables to explore normality

*2017 experimental areas, explore descriptives
by shotspotter, sort : summarize timetodispatch disptoarrive investigative totaltime if (year>=2017 & month>=8 | year>=2018) & sssaug2017==1, detail


*2. formally test normality using Skew and Shapiro-Wilk Normality tests

*skew/kurtosis test
*2017 experimental areas, performs skew/kurtosis test
sktest timetodispatch disptoarrive investigative totaltime if (year>=2017 & month>=8 | year>=2018) & sssaug2017==1
*Shapiro-Wilk test
*2017 experimental areas, performs Shapiro-Wilk test
swilk timetodispatch disptoarrive investigative totaltime if (year>=2017 & month>=8 | year>=2018) & sssaug2017==1


*3. Wilcoxon Rank Sum Test -Mann Whitney U test comparing mean differences in AGDS vs citizen calls for shots fired

*2017 Experimental areas performs non-parametric Man Whitney U test
ranksum timetodispatch if (year>=2017 & month>=8 | year>=2018) & sssaug2017==1, by(shotspotter)
ranksum disptoarrive if (year>=2017 & month>=8 | year>=2018) & sssaug2017==1, by(shotspotter)
ranksum investigative if (year>=2017 & month>=8 | year>=2018) & sssaug2017==1, by(shotspotter)
ranksum totaltime if (year>=2017 & month>=8 | year>=2018) & sssaug2017==1, by(shotspotter)

clear all



*__________________________________________________________________________________________________________________________________________________________________________

* note timeselector=80 and 104 correspond to start of 2017 and 2019 . 56 and 104 corresponds to a 2 year frame, 68 and 92 a one year frame, 48 through 112 is maximum 
*__________________________________________________________________________________________________________________________________________________________________________

*point to data file, replace ... with your directory
use "...\impacteval.dta"

*sets date and geograhic levels to month x census tract

xtset tract statadatum

*2017 Final Difference in Difference models with table generator (tables may not work in all versions of Stata), using two year pre and post observations.

*Shots fired calls reported by citizens
putdocx begin
putdocx paragraph, style(Heading1)
putdocx text ("DID results 2017")
menbreg shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
putdocx table bweight = etable, title("Shots fired")
putdocx save shots

*Shots fired calls by citizens and ShotSpotter
putdocx begin
putdocx paragraph, style(Heading1)
putdocx text ("DID results 2017")
menbreg gunfire i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
putdocx table bweight = etable, title("All shots -including SS")
putdocx save shots, append

*Aggravated assaults w firearm
putdocx begin
putdocx paragraph, style(Heading1)
putdocx text ("DID results 2017")
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
putdocx table bweight = etable, title("Aggravated Assault w gun")
putdocx save shots, append



*Sensitivity dropping one 2017 treatment tract at a time. This tells us if any one of the experimental tract is driving results the overall results more so than others (or completely)

mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=26700|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=2200|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=1900|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=3600|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=27000|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=6600|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=6800|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) & tract!=6900|| tract:, irr



* Variations in dependent variables


*raw categories, not gun specific
menbreg aggravatedass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg robbery i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg minorassault i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr


*variations on aggravated assault, respectively: outdoor only gun assaults, gunassaults (used in final) and outdoor gun assaults that are non-domestic.
menbreg outdoorgunaggassault i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol  PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg aggassnondomoutgun i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr

*additional models
menbreg aggassresidwgun i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg nongunagass i.year i.month i.dotm i.weekendday dirpatrol  PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr


*Determine best model fit, neg binomial versus poisson using LRtest

*LrTest 2017 compare poisson to neg binomial - indicates this model is leaning Poisson -although results are identical (nbinomial mode is converging into poisson)
menbreg shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr 
est store mnegbinomialshots
mepoisson shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr 
est store mpoissonshots 
lrtest mnegbinomialshots mpoissonshots, stats force


menbreg gunfire i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr 
est store mnegbinomialgun
mepoisson gunfire i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr 
est store mpoissongun
lrtest mnegbinomialgun mpoissongun, stats force
 
 
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr 
est store mpoissonag
menbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr 
est store mnegbinomialag
lrtest mpoissonag mnegbinomialag , stats force



*MODEL VARIATIONS, additional robustness checks


*Time series approximation GLM models with no control neighborhoods (compare coefficients to next batch)
glm gunrobbery i.tract i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.exptime2017 if (full2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial 1) link(log) vce(cluster tract) eform
glm gunaggass i.tract i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.exptime2017 if (full2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial 1) link(log) vce(cluster tract) eform
glm gunmassault i.tract i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.exptime2017 if (full2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial 1) link(log) vce(cluster tract) eform

*time series approximation for control neighborhoods, compare to above
glm gunrobbery i.tract i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.exptime2017 if (controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial 1) link(log) vce(cluster tract) eform
glm gunaggass i.tract i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.exptime2017 if (controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial 1) link(log) vce(cluster tract) eform
glm gunmassault i.tract i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.exptime2017 if (controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial 1) link(log) vce(cluster tract) eform

*Length of measurement, which produces largest effect: One year models do. 
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=68 & timeselector<=92 )|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr

*with robust standard errors
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr vce(robust)

*stripped down model, first without control, second without controls and time factors
mepoisson gunaggass i.year i.month  i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
mepoisson gunaggass i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr


*include all tracts as control
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (timeselector>=56 & timeselector<=104 )|| tract:, irr

*can directed patrol impact results?
mepoisson gunaggass i.year i.month i.dotm i.weekendday PRCP TMAX  i.full2017##c.dirpatrol if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
mepoisson gunaggass i.year i.month i.full2017##c.dirpatrol##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
mepoisson gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017  i.full2017#c.dirpatrol if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr

 
 *linear model variations
  * standard linear mixed effect model
 mixed gunaggass i.year i.month i.dotm i.weekendday dirpatrol       PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, vce(robust)

  *  averaged negative binomial model with AR 1 error structure. Same as xtgee model below. usefull to explore potential impact of autocorrelation, but sensitive to small number of clusters (n<50)..
 xtnbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), pa corr(ar 1) irr
 xtgee gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial) link(log) corr(ar 1) eform
 
 *Prais-Winston regression with panel corrected standard errors, not appropriate for non-normal count data, but can help understand autocorrelation bias; similar to xtgee mode above; note that coefficients are raw change.
 xtpcse  gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), correlation(psar1) rhotype(tscorr)
 
 *GLS linear model with AR1 corrected SE & Baltagi-Wu (range 1.5 to 2.5 is acceptable for DW). Probably the best way to check for time correlated issues
 xtregar gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), re rhotype(tscorr) lbi
 xtregar gunaggass  i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), re rhotype(tscorr) lbi

  *Generalized negative binomial model with clustered census tract standard errors. You can replace nbinomial with poisson or gaussian for different distributions
 glm   gunaggass i.tract i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ), family(nbinomial 1) link(log) vce(cluster tract) eform

*Multilevel generalized models are good for comparing various standard error combinations and nearly identical to menbreg.  Models automatically cluster standard errors by census tract. Large differences between regular and robust SEs indicate misspecification and/or heteroskedasticity.

 meglm gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) || tract:, family(nbinomial) link(log) vce(robust) irr
 meglm gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 ) || tract:, family(nbinomial) link(log) irr


 
*time sensitivity models

*Final fine-tuning models 2017

* 2017 experiment final models with max time and full coverage (unbalanced time periods)

*shots fired metrics
menbreg shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
menbreg gunfire i.year i.month i.dotm i.weekendday dirpatrol  PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr

*gun only
menbreg gunrobbery i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
menbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
menbreg gunmassault i.year i.month i.dotm i.weekendday dirpatrol  PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr

* 2017 experiment final models with one year pre and post

*shots fired metrics 
menbreg shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=68 & timeselector<=92 )|| tract:, irr
menbreg gunfire i.year i.month i.dotm i.weekendday dirpatrol  PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=68 & timeselector<=92 )|| tract:, irr

*gun only
menbreg gunrobbery i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=68 & timeselector<=92 )|| tract:, irr
menbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=68 & timeselector<=92 )|| tract:, irr
menbreg gunmassault i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=68 & timeselector<=92 )|| tract:, irr

* 2017 experiment final models with two year pre and post

*shots fired metrics
menbreg shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg gunfire i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr

*gun only
menbreg gunrobbery i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg gunmassault i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.full2017##i.exptime2017 if (full2017==1 | controlfull2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr



*2017 partial coverage fine tune (not enough groups to really be meaningful, however)

* 2017 experiment final models with max time and part coverage


*shots fired metrics
menbreg shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
menbreg gunfire i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr


*gun only
*menbreg gunhomicide i.year i.month i.dotm i.weekendday dirpatrol  PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
menbreg gunrobbery i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
menbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr
menbreg gunmassault i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=48 & timeselector<=112 )|| tract:, irr


* 2017 experiment final models with two year

*shots fired metrics
menbreg shots i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=56 & timeselector<=104)|| tract:, irr
menbreg gunfire i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=56 & timeselector<=104)|| tract:, irr

*gun only
*menbreg gunhomicide i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=56 & timeselector<=104)|| tract:, irr
menbreg gunrobbery i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg gunaggass i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr
menbreg gunmassault i.year i.month i.dotm i.weekendday dirpatrol PRCP TMAX i.part2017##i.exptime2017 if (part2017==1 | controlpart2017==1)& (timeselector>=56 & timeselector<=104 )|| tract:, irr



log close


